#ifndef STR_H
#define STR_H

#include <algorithm>
#include <cstring>
#include <cctype>

using std::isspace;

#include "Vec.h"

class Str {
	// opertor vstupu implementovan na strnce ###12.3.2/216###
	friend std::istream& operator>>(std::istream&, Str&);
	friend std::istream& getline(std::istream&, Str&);
public:
	Str& operator+=(const Str& s) {
		std::copy(s.data.begin(), s.data.end(),
		          std::back_inserter(data));
		return *this;
	}

	// jako dve
	typedef Vec<char>::size_type size_type;

	Str() { }
	Str(size_type n, char c): data(n, c) { }
	Str(const char* cp) {
		std::copy(cp, cp + std::strlen(cp), std::back_inserter(data));
	}
	template <class Vstup> Str(Vstup i, Vstup j) {
		std::copy(i, j, std::back_inserter(data));
	}

	char& operator[](size_type i) { return data[i]; }
	const char& operator[](size_type i) const { return data[i]; }
	size_type size() const { return data.size(); }

	typedef char* iterator;
	typedef const char* const_iterator;

	iterator begin() { return data.begin(); }
	const_iterator begin() const { return data.begin(); }

	iterator end() { return data.end(); }
	const_iterator end() const { return data.end(); }

private:
	Vec<char> data;
};

// opertor vstupu implementovan na strnce ###12.3.2/216###
std::ostream& operator<<(std::ostream&, const Str&);

Str operator+(const Str&, const Str&);
inline bool operator<(const Str& lso, const Str& pso)
{
	return std::lexicographical_compare(lso.begin(), lso.end(), pso.begin(), pso.end());
}
inline bool operator>(const Str& lso, const Str& pso)
{
	return std::lexicographical_compare(pso.begin(), pso.end(), lso.begin(), lso.end());
}
inline bool operator<=(const Str& lso, const Str& pso)
{
	return !std::lexicographical_compare(pso.begin(), pso.end(), lso.begin(), lso.end());

}
inline bool operator>=(const Str& lso, const Str& pso)
{
	return !std::lexicographical_compare(lso.begin(), lso.end(), pso.begin(), pso.end());

}
inline bool operator==(const Str& lso, const Str& pso)
{
	return lso.size() == pso.size() &&
		std::equal(lso.begin(), lso.end(), pso.begin());
}
inline bool operator!=(const Str& lso, const Str& pso)
{
	return !(lso == pso);
}

#endif

