#include <algorithm>
#include <iomanip>
#include <iostream>
#include <stdexcept>
#include "Str.h"
#include "Vec.h"

using std::max;

using std::cin;
using std::cout;
using std::domain_error;
using std::endl;
using std::istream;
using std::ostream;
using std::setprecision;
using std::setw;
using std::sort;
using std::streamsize;

struct Student_info {
	Str jmeno;
	double polovina, zaver;
	Vec<double> domaciukol;
};	// vimnte si stednku - je povinn

// spot stedn hodnotu z 'Vec<double>'
// vimnte si, e voln tto funkce kopruje cel argument 'Vec'
double stred(Vec<double> vec)
{
	typedef Vec<double>::size_type vec_vel;
	
	vec_vel velikost = vec.size();

	if (velikost == 0)
		throw domain_error("stredni hodnota prazdneho objektu Vec");

	sort(vec.begin(), vec.end());

	vec_vel pros = velikost/2;

	return velikost % 2 == 0 ? (vec[pros] + vec[pros-1]) / 2 : vec[pros];
}

// spot zvrenou znmku studenta ze znmek zkouky v polovin, na zvr kurzu a z domcch kol
double znamka(double polovina, double zaver, double domaciukol)
{
	return 0.2 * polovina + 0.4 * zaver + 0.4 * domaciukol;
}

// spot zvrenou znmku studenta ze znmek zkouky v polovin, na zvr kurzu
// a znmek domacch kol z objektu Vec
// tato funkce nekopruje svj argument, protoe to pro ns dl funkce 'stred'
double znamka(double polovina, double zaver, const Vec<double>& du)
{
	if (du.size() == 0)
		throw domain_error("student neudelal zadny domaci ukol");
	return znamka(polovina, zaver, stred(du));
}

double znamka(const Student_info& s)
{
	return znamka(s.polovina, s.zaver, s.domaciukol);
}

// nate znmky z domcch kol ze vstupnho proudu do 'Vec<double>'
istream& cteni_du(istream& vstup, Vec<double>& du)
{
	if (vstup) {
		// vymae pedchoz obsah
		du.clear();

		// nate znmky z domcch kol
		double x;
		while (vstup >> x)
			du.push_back(x);

		// vyist proud, aby vstup fungoval sprvn i pro dalho studenta
		vstup.clear();
	}
	return vstup;
}

istream& cteni(istream& vstup, Student_info& s)
{
	// nate a ulo studentovo jmno a znmky v polovin a na zvr kurzu
	vstup >> s.jmeno >> s.polovina >> s.zaver;

	cteni_du(vstup, s.domaciukol);  // nate a ulo vechny znmky z domcch kol
	return vstup;
}

bool porovnani(const Student_info& x, const Student_info& y)
{
	return x.jmeno < y.jmeno;
}

int main()
{
	Vec<Student_info> studenti;
	Student_info zaznam;
	Str::size_type maxdelka = 0;

	// nate a ulo vechny zznamy a nalezne dlku nejdelho jmna
	while (cteni(cin, zaznam)) {
		maxdelka = max(maxdelka, zaznam.jmeno.size());
		studenti.push_back(zaznam);
	}

	// sead zznamy podle abecedy
	sort(studenti.begin(), studenti.end(), porovnani);

	for (Vec<Student_info>::size_type i = 0;
	     i != studenti.size(); ++i) {

		// vype jmno doplnn zprava na 'maxdelka' '+' '1' znak
		cout << studenti[i].jmeno
		     << Str(maxdelka + 1 - studenti[i].jmeno.size(), ' ');

		// spot a vype znmku
		try {
			double zaverecna_znamka = znamka(studenti[i]);
			streamsize presnost = cout.precision();
			cout << setprecision(3) << zaverecna_znamka
			     << setprecision(presnost);
		} catch (domain_error e) {
			cout << e.what();
		}

		cout << endl;
	}

	return 0;
}