#include <algorithm>
#include <iomanip>
#include <ios>
#include <iostream>
#include <stdexcept>
#include "Str.h"
#include "Vec.h"
#include "znamka.h"
#include "Student_info.h"

using std::cin;                     using std::setprecision;
using std::cout;                    using std::sort;
using std::domain_error;            using std::streamsize;
using std::endl;                    using std::max;

int main()
{
	Vec<Student_info> studenti;
	Student_info zaznam;
	Str::size_type maxdelka = 0;       // dlka nejdelho jmna

	// nate a ulo vechna data student
	// Invariant:	'studenti' obsahuje vechny doposud naten zznamy student
	//				'maxdelka' obsahuje dlku nejdelho jmna v 'studenti'
	while (cteni(cin, zaznam)) {
		// nalezne dlku nejdelho jmna
		maxdelka = max(maxdelka, zaznam.jmeno.size());
		studenti.push_back(zaznam);
	}

	// sead zznamy podle abecedy
	sort(studenti.begin(), studenti.end(), porovnani);

	// vype jmna a znmky
	for (Vec<Student_info>::size_type i = 0;
	     i != studenti.size(); ++i) {

		// vype jmno doplnn zprava na 'maxdelka' '+' '1' znak
		cout << studenti[i].jmeno
		     << Str(maxdelka + 1 - studenti[i].jmeno.size(), ' ');

		// spot a vype znmku
		try {
			double zaverecna_znamka = znamka(studenti[i]);
			streamsize presnost = cout.precision();
			cout << setprecision(3) << zaverecna_znamka
			     << setprecision(presnost);
		} catch (domain_error e) {
			cout << e.what();
		}
		cout << endl;
	}
	return 0;
}